"use strict";
// Copyright 2020 The Kubeflow Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var k8sHelper = __importStar(require("../k8s-helper"));
/**
 * podInfoHandler retrieves pod info and sends back as JSON format.
 */
exports.podInfoHandler = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, podname, podnamespace, podName, podNamespace, _b, pod, err, message, additionalInfo;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = req.query, podname = _a.podname, podnamespace = _a.podnamespace;
                if (!podname) {
                    // 422 status code "Unprocessable entity", refer to https://stackoverflow.com/a/42171674
                    res.status(422).send('podname argument is required');
                    return [2 /*return*/];
                }
                if (!podnamespace) {
                    res.status(422).send('podnamespace argument is required');
                    return [2 /*return*/];
                }
                podName = decodeURIComponent(podname);
                podNamespace = decodeURIComponent(podnamespace);
                return [4 /*yield*/, k8sHelper.getPod(podName, podNamespace)];
            case 1:
                _b = __read.apply(void 0, [_c.sent(), 2]), pod = _b[0], err = _b[1];
                if (err) {
                    message = err.message, additionalInfo = err.additionalInfo;
                    console.error(message, additionalInfo);
                    res.status(500).send(message);
                    return [2 /*return*/];
                }
                res.status(200).send(JSON.stringify(pod));
                return [2 /*return*/];
        }
    });
}); };
exports.podEventsHandler = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, podname, podnamespace, podName, podNamespace, _b, eventList, err, message, additionalInfo;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = req.query, podname = _a.podname, podnamespace = _a.podnamespace;
                if (!podname) {
                    res.status(422).send('podname argument is required');
                    return [2 /*return*/];
                }
                if (!podnamespace) {
                    res.status(422).send('podnamespace argument is required');
                    return [2 /*return*/];
                }
                podName = decodeURIComponent(podname);
                podNamespace = decodeURIComponent(podnamespace);
                return [4 /*yield*/, k8sHelper.listPodEvents(podName, podNamespace)];
            case 1:
                _b = __read.apply(void 0, [_c.sent(), 2]), eventList = _b[0], err = _b[1];
                if (err) {
                    message = err.message, additionalInfo = err.additionalInfo;
                    console.error(message, additionalInfo);
                    res.status(500).send(message);
                    return [2 /*return*/];
                }
                res.status(200).send(JSON.stringify(eventList));
                return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=pod-info.js.map